﻿using System;
using System.Linq;

namespace EventTracker.DAL.Common
{
    public abstract class BaseRepository<T> : IRepository<T>
        where T : class
    {
        public BaseRepository(EventTracker.DAL.EventTrackerEntityDiagrams context)
        {
            _context = context;
        }

        public virtual IQueryable<T> Select()
        {
            throw new NotImplementedException();
        }

        public virtual void Add(T entity)
        {
            Context.Add(entity);
        }

        public virtual void Remove(T entity)
        {
            Context.Delete(entity);
        }

        public virtual void SaveChanges()
        {
            Context.SaveChanges();
        }

        #region Properties

        protected EventTracker.DAL.EventTrackerEntityDiagrams _context;
        public EventTracker.DAL.EventTrackerEntityDiagrams Context
        {
            get { return _context; }
        }

        #endregion
    }
}
