﻿using System;
using System.Linq;
using EventTracker.DAL.Common;

namespace EventTracker.DAL.Repository
{
    public class ConferenceRepository : BaseRepository<Conference>
    {
        public ConferenceRepository(EventTracker.DAL.EventTrackerEntityDiagrams context)
            : base(context)
        {
        }

        public override IQueryable<Conference> Select()
        {
            return Context.Conferences;
        }

        public bool IsConferenceOrganizer(Conference conference, Person person)
        {
            return conference.Organizers.Where(o => o.Person == person).FirstOrDefault() != null;
        }
    }
}
