﻿using System;
using System.Linq;
using EventTracker.DAL.Common;

namespace EventTracker.DAL.Repository
{
    public class PersonRepository : BaseRepository<Person>
    {
        public PersonRepository(EventTracker.DAL.EventTrackerEntityDiagrams context) : base(context)
        {
            
        }

        public override IQueryable<Person> Select()
        {
            return Context.People;
        }

        public Person GetByUsername(string username)
        {
            return Context.People.Where(p => p.Username == username).FirstOrDefault();
        }

        public Person GetByID(int id)
        {
            return Context.People.Where(p => p.ID == id).FirstOrDefault();
        }
    }
}
