﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using EventTracker.SLDashboard.EventTracker.OService;
using GalaSoft.MvvmLight.Messaging;

namespace EventTracker.SLDashboard.Views
{
    public partial class ConferenceView : UserControl
    {
        public ConferenceView()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(ConferenceView_Loaded);
        }

        void ConferenceView_Loaded(object sender, RoutedEventArgs e)
        {
            Messenger.Default.Register<ObservableCollection<Conference>>(this, "ConferencesLoaded", ConferencesLoaded);

            Messenger.Default.Register<ObservableCollection<Track>>(this, "TracksLoaded", TracksLoaded);            

            Messenger.Default.Send<string>("go", "GetConferences");
        }

        public void ConferencesLoaded(ObservableCollection<Conference> conferences)
        {
            xConferencesListBox.ItemsSource = conferences;
        }

        void TracksLoaded(ObservableCollection<Track> tracks)
        {
            xTracksListBox.ItemsSource = tracks;
        }

        private void xConferencesListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (xConferencesListBox.SelectedItem != null)
            {
                Messenger.Default.Send<Conference>((xConferencesListBox.SelectedItem as Conference), "SetCurrentConference");
                Messenger.Default.Send<string>("go", "GetTracks");   
            }
        }

        private void xTracksListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (xTracksListBox.SelectedItem != null)
                Messenger.Default.Send<Track>((xTracksListBox.SelectedItem as Track), "SetCurrentTrack");
        }
    }
}
