﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using EventTracker.SLDashboard.EventTracker.OService;
using GalaSoft.MvvmLight.Messaging;

namespace EventTracker.SLDashboard.Views
{
    public partial class SessionControl : UserControl
    {
        public SessionControl()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(SessionControl_Loaded);
        }

        void SessionControl_Loaded(object sender, RoutedEventArgs e)
        {
            Messenger.Default.Register<string>(this, "SessionConferenceTrack", SetSessionConferenceTrack);

            Messenger.Default.Register<ObservableCollection<Session>>(this, "SendSessionsList", SessionListReceived);

            Messenger.Default.Send<string>("go", "GoSessionViewLoaded");

            // TEST
            //MakeSessions();
        }

        void MakeSessions()
        {
            IList<Session> sessions = new List<Session>();

            for (int i = 0; i < 10; i++)
            {
                Session ssn = new Session();
                ssn.Description = "This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. This is some text to make the session look interesting. ";
                ssn.EndTime = DateTime.Now;
                ssn.StartTime = DateTime.Now.AddHours(-1.5);
                ssn.SkillLevel = 300;
                ssn.Title = "Adventures in Xaml";
                ssn.ID = i;

                ssn.Speaker = new Speaker() { Person = new Person() { FirstName = "Mister", LastName = "Freeze" } };

                sessions.Add(ssn);
            }

            xSessionTileView.ItemsSource = sessions;
        }

        void SetSessionConferenceTrack(string ConferenceTrack)
        {
            string[] divide = ConferenceTrack.Split('|');

            xConferenceNameText.Text = divide[0];
            xConferenceTrackText.Text = divide[1];
        }

        void SessionListReceived(ObservableCollection<Session> sessions)
        {
            if (sessions != null)
            {
                xSessionTileView.ItemsSource = sessions.OrderBy(x => x.StartTime);
            }
        }

        private void xConferenceNameText_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            (Application.Current.RootVisual as MainPage).SwapAdminPanelVisibility();
        }
    }
}
