﻿using System;
using System.Linq;
using System.Xml.Linq;

namespace EventTracker.SLDashboard
{
    public static class XElementExtensions
    {
        public static XElement GetInlineEntries(this XElement xe)
        {
            return xe.Elements()
                .Where(x => x.Name.LocalName == "inline")
                .Single().Elements()
                .Where(x => x.Name.LocalName == "entry")
                .Single();
        }

        public static XElement GetAttributeElement(this XElement xe, string elementName, XName xn, string attributeName)
        {
            return xe.Elements()
                .Where(x => x.Name.LocalName == elementName)
                .Where(x => x.HasAttributes == true)
                .Where(x => x.Attribute(xn).Value == attributeName)
                .Single();
        }

        public static XElement GetContentProps(this XElement xe)
        {            
            return xe.Elements()
                .Where(x => x.Name.LocalName == "content")
                .Single().Elements()
                .Where(x => x.Name.LocalName == "properties")
                .Single();
        }

        public static string GetLocalNameProperty(this XElement xe, string propertyName)
        {
            return xe.Elements().Where(x => x.Name.LocalName == propertyName).Single().Value;
        }

        public static int GetLocalNameIntProperty(this XElement xe, string propertyName)
        {
            return Convert.ToInt32(xe.Elements().Where(x => x.Name.LocalName == propertyName).Single().Value);
        }

        public static DateTime GetLocalNameDateTimeProperty(this XElement xe, string propertyName)
        {
            return Convert.ToDateTime(xe.Elements().Where(x => x.Name.LocalName == propertyName).Single().Value);
        }
    }
}
