﻿using System.Linq;
using System.Web.Mvc;
using EventTracker.Infrastructure;

namespace EventTracker.Controllers
{
    public class OrganizerController : Controller
    {
        readonly IContextManager _contextMgr;

        public OrganizerController(IContextManager contextMgr)
        {
            _contextMgr = contextMgr;
        }

        //
        // GET: /Organizer/
        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public ActionResult _AjaxLoading(int ConferenceId, string text)
        {
            var people = _contextMgr.PersonRepository
                                    .Select()
                                    .Where(p => p.IsOrganizer)//.ToList()
                                    //.Where(p => p.Organizers
                                    //    .Intersect(conference.Organizers)
                                    //    .Count() < 1)
                                    .Select(s => new {FullName = s.FirstName + " " + s.LastName, PersonID = s.ID })
                                    .Where(q => q.FullName.StartsWith(text));

            return new JsonResult { Data = new SelectList(people.ToList(), "PersonID", "FullName") };
        }
    }
}
