﻿using System.Linq;
using System.Web.Mvc;
using EventTracker.Infrastructure;

namespace EventTracker.Controllers
{
    public class SpeakersController : Controller
    {
        private readonly IContextManager _contextMgr;

        public SpeakersController(IContextManager contextMgr)
        {
            _contextMgr = contextMgr;
        }

        public ActionResult AjaxLoading()
        {
            return View();
        }

        [HttpPost]
        public ActionResult _AjaxLoading(string text)
        {
            var speakers = _contextMgr.PersonRepository.Select()
                .Where(p => p.IsSpeaker)
                .Select(s => new { FullName = s.FirstName + " " + s.LastName, PersonID = s.ID })
                .Where(q => q.FullName.StartsWith(text));

            return new JsonResult { Data = new SelectList(speakers.ToList(), "PersonID", "FullName") };
        }

        [HttpPost]
        public ActionResult _AutoCompleteAjaxLoading(string text)
        {
            var speakers = _contextMgr.PersonRepository.Select()
                .Where(p => p.IsSpeaker)
                .Select(s => new { FullName = s.FirstName + " " + s.LastName, PersonID = s.ID })
                .Where(q => q.FullName.StartsWith(text));

            return new JsonResult { Data = new SelectList(speakers.ToList(), "PersonID", "FullName") };
        }

//        //
//        // GET: /Speakers/

//        public ActionResult Index()
//        {
//            var speakers = SpeakerRepo.Select()
//                                                .ToList()
//                                                .Select(speaker => Mapper.Map<Speaker, SpeakerModel>(speaker));

//            return View(speakers);
//        }

//        //
//        // GET: /Speakers/Details/5

//        public ActionResult Details(int id)
//        {
//            Speaker speaker = SpeakerRepo.Select().Where(s => s.Id == id).FirstOrDefault();

//            if (speaker == null) return View("Error", "Speaker not found.");

//            var model = Mapper.Map<Speaker, SpeakerModel>(speaker);

//            return View(model);
//        }

//        //
//        // GET: /Speakers/Create
//        [Authorize]
//        public ActionResult Create()
//        {
//            return View();
//        } 

//        //
//        // POST: /Speakers/Create
//        [HttpPost]
//        [Authorize]
//        public ActionResult Create(SpeakerModel model, FormCollection collection)
//        {
//            try
//            {
//                Speaker speaker = new Speaker();
//                speaker.FullName = model.FullName;
//                speaker.Biography = model.Biography;
//                SpeakerRepo.Add(speaker);
//                SpeakerRepo.SaveChanges();

//                return RedirectToAction("Index");
//            }
//            catch (Exception ex)
//            {
//                return View();
//            }
//        }
        
//        //
//        // GET: /Speakers/Edit/5
//        [Authorize]
//        public ActionResult Edit(int id)
//        {
//            Speaker speaker = SpeakerRepo.Select().Where(s => s.Id == id).FirstOrDefault();

//            if (speaker == null) return View("Error", "Speaker not found.");

//            var model = Mapper.Map<Speaker, SpeakerModel>(speaker);

//            return View(model);
//        }

//        //
//        // POST: /Speakers/Edit/5

//        [HttpPost]
//        [Authorize]
//        public ActionResult Edit(SpeakerModel model, FormCollection collection)
//        {
//            try
//            {
//                Speaker speaker = SpeakerRepo.Select().Where(s => s.Id == model.Id).FirstOrDefault();

//                if (speaker == null) return View("Error", "Speaker not found.");

//                speaker.FullName = model.FullName;
//                speaker.Biography = model.Biography;
//                SpeakerRepo.SaveChanges();
 
//                return RedirectToAction("Details", new { id=speaker.Id });
//            }
//            catch
//            {
//                return View();
//            }
//        }

//        //
//        // GET: /Speakers/Delete/5
//        [Authorize]
//        public ActionResult Delete(int id)
//        {
//            return View();
//        }

//        //
//        // POST: /Speakers/Delete/5

//        [HttpPost]
//        [Authorize]
//        public ActionResult Delete(int id, FormCollection collection)
//        {
//            try
//            {
//                // TODO: Add delete logic here
 
//                return RedirectToAction("Index");
//            }
//            catch
//            {
//                return View();
//            }
//        }

//        #region Properties

//        SpeakerRepository _speakerRepository;
//        SpeakerRepository SpeakerRepo
//        {
//            get
//            {
//                if (_speakerRepository == null)
//                    _speakerRepository = new SpeakerRepository();

//                return _speakerRepository;
//            }
//        }

//        #endregion
    }
}
