﻿using AutoMapper;
using EventTracker.DAL;
using EventTracker.Models;

namespace EventTracker.Infrastructure
{
    public class AutoMapperConfiguration
    {
        public static void Run()
        {
            //Example
            //This is only required if the names of the properties do not match
            //Mapper.CreateMap<SRC TYPE, DEST TYPE>()
                    //Explicit Mappings are  only required if the names of the properties do not match
            //      .ForMember(destination => destination.PROPERTY, options => options.MapFrom(source => source.PROPERTY));

            Mapper.CreateMap<Conference, ConferenceModel>();
            Mapper.CreateMap<ConferenceModel, Conference>();
            Mapper.CreateMap<Track, TrackModel>();
            Mapper.CreateMap<TrackModel, Track>();
            Mapper.CreateMap<Session, SessionModel>()
                .ForMember(s => s.Speaker, options => options.Ignore());

            Mapper.CreateMap<SessionModel, Session>()
                .ForMember(s => s.Speaker, options => options.Ignore()); // Speaker needs to be assigned manually

            //Mapper.CreateMap<Track, TrackModel>();
            //    //.ForMember(destination => destination.ConferenceName, options => options.MapFrom(source => source.Conference != null ? source.Conference.Name : string.Empty));
            //Mapper.CreateMap<Session, SessionModel>();
            //Mapper.CreateMap<Speaker, SpeakerModel>();
        }
    }
}