﻿using EventTracker.DAL.Repository;

namespace EventTracker.Infrastructure
{
    public class ContextManager : EventTracker.Infrastructure.IContextManager
    {
        private readonly EventTracker.DAL.EventTrackerEntityDiagrams _context;
        private ConferenceRepository _conferenceRepository;
        private PersonRepository _personRepository;
        private OrganizerRepository _organizerRepository;
        private TrackRepository _trackRepository;
        private SessionRepository _sessionRepository;
        private SpeakerRepository _speakerRepository;

        public ContextManager()
        {
            _context = new DAL.EventTrackerEntityDiagrams();
            
            _conferenceRepository = new ConferenceRepository(_context);
            _personRepository = new PersonRepository(_context);
            _organizerRepository = new OrganizerRepository(_context);
            _sessionRepository = new SessionRepository(_context);
            _trackRepository = new TrackRepository(_context);
            _speakerRepository = new SpeakerRepository(_context);
        }

        public EventTracker.DAL.EventTrackerEntityDiagrams Context
        {
            get { return _context; }
        }

        public ConferenceRepository ConferenceRepository
        {
            get { return _conferenceRepository; }
            set { _conferenceRepository = value; }
        }

        public PersonRepository PersonRepository
        {
            get { return _personRepository; }
            set { _personRepository = value; }
        }

        public OrganizerRepository OrganizerRepository
        {
            get { return _organizerRepository; }
            set { _organizerRepository = value; }
        }

        public TrackRepository TrackRepository
        {
            get { return _trackRepository; }
            set { _trackRepository = value; }
        }

        public SessionRepository SessionRepository
        {
            get { return _sessionRepository; }
            set { _sessionRepository = value; }
        }

        public SpeakerRepository SpeakerRepository
        {
            get { return _speakerRepository; }
            set { _speakerRepository = value; }
        }
    }
}