﻿using System.Drawing;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace EventTracker.Infrastructure.Helpers
{
    public class StyleHelper
    {
            

            private static void RadGrid_UpdateRowNumber(object sender, Telerik.Web.UI.GridItemEventArgs e)
            {
                GridDataItem dataBoundItem = e.Item as GridDataItem;
                if (dataBoundItem != null)
                {
                    RadGrid gridView = (RadGrid)sender;
                    int page = gridView.CurrentPageIndex; // starts at 0
                    int pagesize = gridView.PageSize;
                    var state = dataBoundItem["#"];
                    state.Text = (e.Item.ItemIndex + 1 + (page * pagesize)).ToString();
                }
            }
            private static void RadGrid_ReplaceMinusOne(object sender, Telerik.Web.UI.GridItemEventArgs e)
            {
                GridDataItem dataBoundItem = e.Item as GridDataItem;
                if (dataBoundItem != null)
                {
                    if (dataBoundItem != null)
                    {
                        foreach (GridColumn col in ((RadGrid)sender).MasterTableView.Columns)
                        {
                            var cell = dataBoundItem[col];
                            if (cell.Text == "-1")
                                cell.Text = " ";
                        }
                    }
                    var s = dataBoundItem["Event Type"].Text;
                    if (string.IsNullOrEmpty(s) == false)
                    {
                        if (s.StartsWith("Context", System.StringComparison.Ordinal))
                            dataBoundItem.BackColor = Color.LightBlue;
                        else if (s.StartsWith("Ado", System.StringComparison.Ordinal))
                            dataBoundItem.BackColor = Color.LightPink;
                    }
                }
            }
            private static void RadGrid_SetStateColors(object sender, Telerik.Web.UI.GridItemEventArgs e)
            {
                GridDataItem dataBoundItem = e.Item as GridDataItem;
                if (dataBoundItem != null)
                {
                    //var state = dataBoundItem["State"];
                    //state.Font.Bold = true;
                    //if (state.Text == TestState.Pass.ToString())
                    //    state.ForeColor = Color.Green;

                    //else if (state.Text == TestState.Fail.ToString())
                    //    state.ForeColor = Color.Red;
                    //else if (state.Text == TestState.Undefined.ToString())
                    //    state.ForeColor = Color.Red;
                    //else if (state.Text == TestState.Untested.ToString())
                    //    state.ForeColor = Color.Red;

                    //else if (state.Text == TestState.Init.ToString())
                    //    state.ForeColor = Color.Goldenrod;
                    //else if (state.Text == TestState.KnownFailure.ToString())
                    //    state.ForeColor = Color.Goldenrod;

                    //else if (state.Text == TestState.Unsupported.ToString())
                    //    state.ForeColor = Color.DarkBlue;
                }
            }
            private static void RadGrid_SetStatisticColors(object sender, Telerik.Web.UI.GridItemEventArgs e)
            {
                GridDataItem dataBoundItem = e.Item as GridDataItem;
                if (dataBoundItem != null)
                {
                    HyperLink link = (HyperLink)dataBoundItem["Fail"].Controls[0];
                    link.ForeColor = Color.Red;
                    link = (HyperLink)dataBoundItem["Known"].Controls[0];
                    link.ForeColor = Color.Goldenrod;
                    link = (HyperLink)dataBoundItem["UTest"].Controls[0];
                    link.ForeColor = Color.Red;
                    //link = (HyperLink)dataBoundItem["USup"].Controls[0];
                    //link.ForeColor = Color.DarkBlue;
                    link = (HyperLink)dataBoundItem["UDef"].Controls[0];
                    link.ForeColor = Color.Red;

                }
            }
            private static void Clear(RadGrid gridView)
            {
                GridColumn keep = null;
                //foreach (GridColumn col in gridView.MasterTableView.Columns)
                //{
                //    if (col.UniqueName == "TemplateColumn-numberLabel")
                //    {
                //        gridView.ItemDataBound += RadGrid_UpdateRowNumber;
                //        keep = col;
                //    }
                //}
                gridView.MasterTableView.Columns.Clear();
                if (keep != null)
                    gridView.MasterTableView.Columns.Add(keep);
            }
            private static void SetUniqueName(RadGrid gridView)
            {
                foreach (GridColumn col in gridView.MasterTableView.Columns)
                {
                    if (string.IsNullOrEmpty(col.UniqueName) == false)
                    {
                        col.UniqueName = col.HeaderText;
                    }
                    GridBoundColumn boundColumn = col as GridBoundColumn;
                    if (boundColumn != null)
                    {
                        if (string.IsNullOrEmpty(boundColumn.DataField) == false && string.IsNullOrEmpty(boundColumn.SortExpression))
                            boundColumn.SortExpression = boundColumn.DataField;
                        else
                            boundColumn.SortExpression = boundColumn.SortExpression;
                    }

                    GridHyperLinkColumn hyperColumn = col as GridHyperLinkColumn;
                    if (hyperColumn != null)
                        if (string.IsNullOrEmpty(hyperColumn.DataTextField) == false && string.IsNullOrEmpty(hyperColumn.SortExpression))
                            hyperColumn.SortExpression = hyperColumn.DataTextField;
                        else
                            hyperColumn.SortExpression = hyperColumn.SortExpression;
                }
            }

            internal static void AddStatisticColumns(RadGrid gridView, string url, string untestedUrl)
            {
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Total", HeaderText = "Total" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Passed", HeaderText = "Pass" });

                var hl = new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = url + "&Filter=fail",
                    DataTextField = "Failed",
                    HeaderText = "Fail",
                };
                hl.ItemStyle.ForeColor = Color.Red;

                gridView.MasterTableView.Columns.Add(hl);
                hl = new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = url + "&Filter=known",
                    DataTextField = "KnownFailure",
                    HeaderText = "Known",
                };
                hl.ItemStyle.ForeColor = Color.DarkOrange;
                gridView.MasterTableView.Columns.Add(hl);

                hl = new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = untestedUrl,
                    DataTextField = "Untested",
                    HeaderText = "UTest",
                };
                hl.ItemStyle.ForeColor = Color.Red;
                gridView.MasterTableView.Columns.Add(hl);

                hl = new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = url + "&Filter=unsupported",
                    DataTextField = "Unsupported",
                    HeaderText = "USupp",
                };
                hl.ItemStyle.ForeColor = Color.DarkBlue;
                gridView.MasterTableView.Columns.Add(hl);

                hl = new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = url + "&Filter=undefined",
                    DataTextField = "Undefined",
                    HeaderText = "UDef",
                };
                hl.ItemStyle.ForeColor = Color.Red;
                gridView.MasterTableView.Columns.Add(hl);

                gridView.ItemDataBound += RadGrid_SetStatisticColors;

            }
            internal static void AddTimeColumns(RadGrid gridView)
            {
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Start", HeaderText = "Start", DataFormatString = "{0:s}" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "End", HeaderText = "End", DataFormatString = "{0:HH:mm:ss}" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Duration", HeaderText = "Duration", DataFormatString = "{0:hh':'mm':'ss'.'fff}", SortExpression = "End - Start" });
            }
            internal static void AddStateColumn(RadGrid gridView)
            {
                gridView.Columns.Add(new GridBoundColumn() { DataField = "State", HeaderText = "State" });
                gridView.ItemDataBound += RadGrid_SetStateColors;
            }
            internal static void AddNumberColumn(RadGrid gridView)
            {
                gridView.MasterTableView.Columns.Add(new GridTemplateColumn() { HeaderText = "#" });
                gridView.ItemDataBound += RadGrid_UpdateRowNumber;
            }

            internal static void AddAssessmentColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.MasterTableView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                   //DataNavigateUrlFormatString = OneAssessmentPage,
                    DataTextField = "Name",
                    HeaderText = "Name",
                });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Product", HeaderText = "Product", SortExpression = "Amount.Product" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Amount", HeaderText = "Amount" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Tester", HeaderText = "Tester" });
                AddStateColumn(gridView);
                AddTimeColumns(gridView);
                //AddStatisticColumns(gridView, AllMethodsPage + "?Id={0}&Operation=Assessment", "~/Amount/AmountMethodsForm.aspx?Operation=Assessment&Id={0}");
                SetUniqueName(gridView);
            }
            internal static void AddConfigurationColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    //DataNavigateUrlFormatString = OneConfigurationPage,
                    DataTextField = "Name",
                    HeaderText = "Name",
                    SortExpression = "AmountConfiguration.Name",
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Computer", HeaderText = "Computer" });
                AddStateColumn(gridView);
                AddTimeColumns(gridView);
               // AddStatisticColumns(gridView, AllMethodsPage + "?Id={0}&Operation=Configuration", "~/Amount/AmountMethodsForm.aspx?Operation=Configuration&Id={0}");
                SetUniqueName(gridView);
            }
            internal static void AddClassColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.MasterTableView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    //DataNavigateUrlFormatString = OneClassPage,
                    DataTextField = "Name",
                    HeaderText = "Name",
                    SortExpression = "AmountClass.Name",
                });
                AddStateColumn(gridView);
                AddTimeColumns(gridView);
               // AddStatisticColumns(gridView, AllMethodsPage + "?Id={0}&Operation=Class", "~/Amount/AmountMethodsForm.aspx?Operation=Class&Id={0}");
                SetUniqueName(gridView);
            }
            internal static void AddMethodColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                   // DataNavigateUrlFormatString = OneMethodPage,
                    DataTextField = "Name",
                    HeaderText = "Name",
                    SortExpression = "AmountMethod.Name",
                });
                AddStateColumn(gridView);
                AddTimeColumns(gridView);
                SetUniqueName(gridView);
            }

            internal static void AddErrorColumns(RadGrid gridView)
            {
                gridView.MasterTableView.Columns.Clear();
                AddNumberColumn(gridView);
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { HeaderText = "Identity", DataField = "Identity", Visible = false });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { HeaderText = "When", DataField = "When" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { HeaderText = "Where", DataField = "Where" });
                gridView.MasterTableView.Columns.Add(new GridBoundColumn() { HeaderText = "Action", DataField = "Action" });
                var hl = new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                   // DataNavigateUrlFormatString = ErrorDetailPage,
                    DataTextField = "What",
                    HeaderText = "Message",
                };
                gridView.MasterTableView.Columns.Add(hl);
                SetUniqueName(gridView);
            }

            internal static void AddMethodViewColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/MethodDetailsForm.aspx?ID={0}",
                    DataTextField = "Name",
                    HeaderText = "Name",
                    SortExpression = "AmountMethod.Name",
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "TestClass.Identity", HeaderText = "TestClassIdentity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "TestClass.Configuration.Identity", HeaderText = "ConfigurationIdentity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "TestClass.Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/ClassForm.aspx?ID={0}",
                    DataTextField = "TestClass.AmountClass.Name",
                    HeaderText = "Class",
                    SortExpression = "TestClass.AmountClass.Name",
                });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "TestClass.Configuration.Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/ConfigurationForm.aspx?ID={0}",
                    DataTextField = "TestClass.Configuration.AmountConfiguration.Name",
                    HeaderText = "Configuration",
                    SortExpression = "TestClass.Configuration.AmountConfiguration.Name",
                });
                AddStateColumn(gridView);
                AddTimeColumns(gridView);
                SetUniqueName(gridView);
            }

            internal static void AddAmountColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = "~/Amount/AmountForm.aspx?ID={0}",
                    DataTextField = "Name",
                    HeaderText = "Name"
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Product", HeaderText = "Product" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Children", HeaderText = "Children" });
                SetUniqueName(gridView);
            }
            internal static void AddAmountConfigurationColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = "~/Amount/AmountConfigurationForm.aspx?ID={0}",
                    DataTextField = "Name",
                    HeaderText = "Name"
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Children", HeaderText = "Children" });
                SetUniqueName(gridView);
            }
            internal static void AddAmountClassColumns(RadGrid gridView, bool withUnlinkColumn)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = "~/Amount/AmountClassForm.aspx?ID={0}",
                    DataTextField = "Name",
                    HeaderText = "Name"
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Children", HeaderText = "Children" });
                if (withUnlinkColumn)
                {
                    gridView.Columns.Add(new GridButtonColumn()
                    {
                        ConfirmText = "Do you really want to unlink these test class from the amount?",
                        ButtonType = GridButtonColumnType.PushButton,
                        Text = "Unlink",
                        DataTextFormatString = "Unlink",
                        CommandName = "Unlink",
                        DataTextField = "Identity",
                        CommandArgument = "Identity",
                    });
                }
                SetUniqueName(gridView);
            }
            internal static void AddAmountMethodColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Name", HeaderText = "Name" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Created", HeaderText = "Created" });
                gridView.Columns.Add(new GridButtonColumn()
                {
                    ConfirmText = "Do you really want to unlink these test method from the amount?",
                    ButtonType = GridButtonColumnType.PushButton,
                    Text = "Unlink",
                    DataTextFormatString = "Unlink",
                    CommandName = "Unlink",
                    DataTextField = "Identity",
                    CommandArgument = "Identity",
                });
                SetUniqueName(gridView);
            }

            internal static void AddAmountMethodsColumns(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "AmountClass.Identity", HeaderText = "AmountClassIdentity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "AmountClass.AmountConfiguration.Identity", HeaderText = "AmountConfigurationIdentity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Name", HeaderText = "Name" });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "AmountClass.Identity" },
                    DataNavigateUrlFormatString = "~/Amount/AmountClassForm.aspx?ID={0}",
                    DataTextField = "AmountClass.Name",
                    HeaderText = "Amount Class"
                });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "AmountClass.AmountConfiguration.Identity" },
                    DataNavigateUrlFormatString = "~/Amount/AmountConfigurationForm.aspx?ID={0}",
                    DataTextField = "AmountClass.AmountConfiguration.Name",
                    HeaderText = "Amount Configuration"
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Created", HeaderText = "Created" });
                gridView.Columns.Add(new GridButtonColumn()
                {
                    ConfirmText = "Do you really want to unlink these test method from the amount?",
                    ButtonType = GridButtonColumnType.PushButton,
                    Text = "Unlink",
                    DataTextFormatString = "Unlink",
                    CommandName = "Unlink",
                    DataTextField = "Identity",
                    CommandArgument = "Identity",
                });
                SetUniqueName(gridView);
            }

            internal static void AddMethodViewColumnsWithAssessment(RadGrid gridView)
            {
                Clear(gridView);
                AddNumberColumn(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Identity", HeaderText = "Identity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/MethodDetailsForm.aspx?ID={0}",
                    DataTextField = "Name",
                    HeaderText = "Name",
                    SortExpression = "AmountMethod.Name",
                });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "TestClass.Identity", HeaderText = "TestClassIdentity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "TestClass.Configuration.Identity", HeaderText = "ConfigurationIdentity", Visible = false });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "TestClass.Configuration.Assessment.Identity", HeaderText = "AssessmentIdentity", Visible = false });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "TestClass.Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/ClassForm.aspx?ID={0}",
                    DataTextField = "TestClass.AmountClass.Name",
                    HeaderText = "Class",
                    SortExpression = "TestClass.AmountClass.Name",
                });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "TestClass.Configuration.Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/ConfigurationForm.aspx?ID={0}",
                    DataTextField = "TestClass.Configuration.AmountConfiguration.Name",
                    HeaderText = "Configuration",
                    SortExpression = "TestClass.Configuration.AmountConfiguration.Name",
                });
                gridView.Columns.Add(new GridHyperLinkColumn()
                {
                    DataNavigateUrlFields = new[] { "TestClass.Configuration.Assessment.Identity" },
                    DataNavigateUrlFormatString = "~/Assessment/AssessmentForm.aspx?ID={0}",
                    DataTextField = "TestClass.Configuration.AmountConfiguration.Name",
                    HeaderText = "Assessment",
                    SortExpression = "TestClass.Configuration.Assessment.Amount.Name",
                });
                AddStateColumn(gridView);
                AddTimeColumns(gridView);
                SetUniqueName(gridView);
            }

            internal static void AddEventColumns(RadGrid gridView)
            {
                Clear(gridView);
                gridView.Columns.Add(new GridBoundColumn() { DataField = "EventId", HeaderText = "ID" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Timestamp", HeaderText = "Start", DataFormatString = "{0:HH:mm:ss}" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Duration", HeaderText = "Duration", DataFormatString = "{0:ss'.'ffffff}" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "EventType", HeaderText = "Event Type" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "Information", HeaderText = "Information", MaxLength = 100, HtmlEncode = true });

                gridView.Columns.Add(new GridBoundColumn() { DataField = "ContextId", HeaderText = "Context" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "ConnectionId", HeaderText = "Connection" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "StatementId", HeaderText = "Command" });
                gridView.Columns.Add(new GridBoundColumn() { DataField = "ResultId", HeaderText = "ResultSet" });
                gridView.ItemDataBound += RadGrid_ReplaceMinusOne;
                SetUniqueName(gridView);
            }
    }
}