﻿using System.Web.Mvc;

namespace EventTracker.Infrastructure
{
    public class StructureMapBootstrapper
    {
        private static StructureMap.Container _container;

        public static void BootstrapStructureMap()
        {
            _container = new StructureMap.Container(x =>
            {
                x.ForSingletonOf<IContextManager>().Use(new ContextManager());
            });

            DependencyResolver.SetResolver(new StructureMapDependencyResolver(_container));
        }

        public static StructureMap.Container Container
        {
            get
            {
                return _container;
            }
        }
    }
}