﻿using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace EventTracker.Models
{
    public class ConferenceModel
    {
        [Required]
        [Editable(false)]
        public int Id { get; set; }

        [Required]
        [DataType(DataType.Text)]
        [DisplayName("Name")]
        public string Name { get; set; }

        [Required]
        [DataType(DataType.MultilineText)]
        [DisplayName("Description")]
        public string Description { get; set; }

        [Required]
        [DataType(DataType.Text)]
        [DisplayName("Event Location")]
        public string Location { get; set; }

        [Required]
        [DataType(DataType.Date)]
        [DisplayName("Start Date")]
        public DateTime StartDate { get; set; }

        [Required]
        [DataType(DataType.Date)]
        [DisplayName("End Date")]
        public DateTime EndDate { get; set; }

        [Required(AllowEmptyStrings = true)]
        [DataType(DataType.Url)]
        [DisplayName("Website Url")]
        public string Website { get; set; }

        [Required]
        [DisplayName("Capacity")]
        public int Capacity { get; set; }
    }
    //public class ListConferenceModel
    //{
    //    [Required]
    //    [Editable(false)]
    //    public int Id { get; set; }
    //    [Required]
    //    [DataType(DataType.Text)]
    //    [DisplayName("Conference name")]
    //    public string Name { get; set; }
    //    [Required]
    //    [DataType(DataType.MultilineText)]
    //    [DisplayName("Description")]
    //    public string Description { get; set; }
    //}
    //public class CreateConferenceModel
    //{
    //    [Required]
    //    [DataType(DataType.Text)]
    //    [DisplayName("Conference name")]
    //    public string Name { get; set; }
    //    [Required]
    //    [DataType(DataType.MultilineText)]
    //    [DisplayName("Description")]
    //    public string Description { get; set; }
    //}
    //public class ConferenceTrackModel
    //{
    //    [Required]
    //    [Editable(false)]
    //    public int Id { get; set; }
    //    [Required]
    //    [DataType(DataType.Text)]
    //    [DisplayName("Title")]
    //    public string Title { get; set; }
    //    [Required]
    //    [DataType(DataType.MultilineText)]
    //    [DisplayName("Description")]
    //    public string Description { get; set; }
    //}
    //public class ConferencesAddTrackModel
    //{
    //    [Required]
    //    [DataType(DataType.Text)]
    //    [DisplayName("Title")]
    //    public string Title { get; set; }
    //    [Required]
    //    [DataType(DataType.MultilineText)]
    //    [DisplayName("Description")]
    //    public string Description { get; set; }
    //}
    //#region Conference Details
    ////public class TrackModel
    ////{
    ////    [Required]
    ////    [DataType(DataType.Text)]
    ////    [DisplayName("")]
    ////    public string Name { get; set; }
    ////}
    //#endregion
}