using System.Collections.Generic;
using EventTracker.DAL;

namespace EventTracker.Models
{
    public class DashboardViewModel
    {
        public IList<Session> Sessions { get; set; }
        public IList<Conference> OrganizerFor { get; set; }
        public IList<Conference> Attending { get; set; }
        public IList<Conference> Attended { get; set; }

        public bool IsAttendee
        {
            get
            {
                return (this.Attending != null && this.Attending.Count > 0) || (this.Attended != null && this.Attended.Count > 0);
            }
        }
        public bool IsSpeaker
        {
            get
            {
                return this.Sessions != null && this.Sessions.Count > 0;
            }
        }
        public bool IsOrganizer
        {
            get
            {
                return this.OrganizerFor != null && this.OrganizerFor.Count > 0;
            }
        }
    }
}