using System;
using Telerik.OpenAccess.Diagnostics;

namespace EventTracker.Models
{
    /// <summary>
    /// Telerik.OpenAccess.Diagnostics.DatabaseMetric is sealed, so we have to wrap it.
    /// </summary>
    public class MetricViewModel
    {
        
        /// <summary>
        /// Initializes a new instance of the <see cref="MetricViewModel" /> class.
        /// </summary>
        public MetricViewModel() {
        }

        public int Connection_Obtained { get;set; }

        public int Sql_Query { get;set; }
        public int Sql_Commit { get;set; }
        public int Sql_FetchedRows { get;set; }
        public int Cache_Object_Hits { get;set; }
        public int Cache_Object_Miss { get;set; }
        public int Cache_Query_Hits { get;set; }
        public int Cache_Query_Miss { get;set; }
        public int Sql_Delete { get;set; }
        public int Sql_Insert { get;set; }
        public int Sql_Update { get;set; }
        public int L2Cache_Query_HitRatio { get;set; }
        public int L2Cache_Query_FillRatio { get;set; }
        public int L2Cache_Object_HitRatio { get;set; }
        public int L2Cache_Object_FillRatio { get;set; }
        public int L2Cache_Query_Hit { get;set; }
        public int L2Cache_Query_Miss { get;set; }
        public int L2Cache_Object_Hit { get;set; }
        public int L2Cache_Object_Miss { get;set; }
        public int Connection_ObtainedWait { get;set; }
        public int Connection_Active { get;set; }
        public int Connection_MaxActive { get;set; }
        public int Connection_Idle { get;set; }
        public int Connection_Validate { get;set; }
        public int Context_Active { get;set; }
        public int Context_MaxActive { get;set; }
        public int Context_Idle { get;set; }

        public DateTime TimeStamp { get;set; }

        public string FormattedTime
        {
            get
            {
                return TimeStamp.ToString("h:mm:ss");
            }
        }
        //public int Connection_Obtained
        //{
        //    get
        //    {
        //        return Metric.Connection_Obtained;
        //    }
        //}
        //public int Sql_Query
        //{
        //    get
        //    {
        //        return Metric.Sql_Query;
        //    }
        //}
        //public int Sql_Commit
        //{
        //    get
        //    {
        //        return Metric.Sql_Commit;
        //    }
        //}
        //public int Sql_FetchedRows
        //{
        //    get
        //    {
        //        return Metric.Sql_FetchedRows;
        //    }
        //}
        //public int Cache_Object_Hits
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Object_Hit;
        //    }
        //}
        //public int Cache_Object_Miss
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Object_Miss;
        //    }
        //}
        //public int Cache_Query_Hits
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Query_Hit;
        //    }
        //}
        //public int Cache_Query_Miss
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Query_Miss;
        //    }
        //}
        //public int Sql_Delete
        //{
        //    get
        //    {
        //        return Metric.Sql_Delete;
        //    }
        //}
        //public int Sql_Insert
        //{
        //    get
        //    {
        //        return Metric.Sql_Insert;
        //    }
        //}
        //public int Sql_Update
        //{
        //    get
        //    {
        //        return Metric.Sql_Update;
        //    }
        //}
        //public int L2Cache_Query_HitRatio
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Query_HitRatio;
        //    }
        //}
        //public int L2Cache_Query_FillRatio
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Query_FillRatio;
        //    }
        //}
        //public int L2Cache_Object_HitRatio
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Object_HitRatio;
        //    }
        //}
        //public int L2Cache_Object_FillRatio
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Object_FillRatio;
        //    }
        //}
        //public int L2Cache_Query_Hit
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Query_Hit;
        //    }
        //}
        //public int L2Cache_Query_Miss
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Query_Miss;
        //    }
        //}
        //public int L2Cache_Object_Hit
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Object_Hit;
        //    }
        //}
        //public int L2Cache_Object_Miss
        //{
        //    get
        //    {
        //        return Metric.L2Cache_Object_Miss;
        //    }
        //}
        //public int Connection_ObtainedWait
        //{
        //    get
        //    {
        //        return Metric.Connection_ObtainedWait;
        //    }
        //}
        //public int Connection_Active
        //{
        //    get
        //    {
        //        return Metric.Connection_Active;
        //    }
        //}
        //public int Connection_MaxActive
        //{
        //    get
        //    {
        //        return Metric.Connection_MaxActive;
        //    }
        //}
        //public int Connection_Idle
        //{
        //    get
        //    {
        //        return Metric.Connection_Idle;
        //    }
        //}
        //public int Connection_Validate
        //{
        //    get
        //    {
        //        return Metric.Connection_Validate;
        //    }
        //}
        //public int Context_Active
        //{
        //    get
        //    {
        //        return Metric.Context_Active;
        //    }
        //}
        //public int Context_MaxActive
        //{
        //    get
        //    {
        //        return Metric.Context_MaxActive;
        //    }
        //}
        //public int Context_Idle
        //{
        //    get
        //    {
        //        return Metric.Context_Idle;
        //    }
        //}
        //public DateTime TimeStamp
        //{
        //    get
        //    {
        //        return Metric.Timestamp;
        //    }
        //}
        //public string FormattedTime
        //{
        //    get
        //    {
        //        return Metric.Timestamp.ToString("HH:mm:ss");
        //    }
        //}
    }
}