﻿using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace EventTracker.Models
{
    public class SessionModel
    {
        [Required]
        [Editable(false)]
        public int Id { get; set; }

        [Required]
        [DataType(DataType.Text)]
        [DisplayName("Title")]
        public string Title { get; set; }

        [Required]
        [DataType(DataType.MultilineText)]
        [DisplayName("Description")]
        public string Description { get; set; }

        [Required]
        [DataType(DataType.DateTime)]
        [DisplayName("Start Time")]
        public DateTime StartTime { get; set; }

        [Required]
        [DataType(DataType.DateTime)]
        [DisplayName("End Time")]
        public DateTime EndTime { get; set; }

        [Required]
        [DataType(DataType.Text)]
        [DisplayName("Speaker")]
        public Int32 Speaker { get; set; }

        [DataType(DataType.Text)]
        [DisplayName("Speaker Name")]
        [Editable(false)]
        [ScaffoldColumn(false)]
        public string SpeakerFullName { get; set; }

        [Required]
        [DataType(DataType.Text)]
        [DisplayName("Skill Level")]
        public Int32 SkillLevel { get; set; }

        [Required]
        [Editable(false)]
        [ScaffoldColumn(false)]
        public int TrackId { get; set; }
    }

    //public class CreateSessionModel : SessionModel
    //{
    //    [Required]
    //    [DataType(DataType.Text)]
    //    [DisplayName("Speaker")]
    //    public Int32 Speaker { get; set; }
    //}

    //public class SessionEditModel
    //{
    //    /// <summary>
    //    /// SkillLevel Property
    //    /// </summary>
    //    [DataType(DataType.Text)]
    //    [DisplayName("Skill Level")]
    //    public int SkillLevel { get; set; }

    //    [Required]
    //    [Editable(false)]
    //    public int Id { get; set; }

    //    [Required]
    //    [DataType(DataType.Text)]
    //    [DisplayName("Title")]
    //    public string Title { get; set; }

    //    [Required]
    //    [DataType(DataType.MultilineText)]
    //    [DisplayName("Description")]
    //    public string Description { get; set; }

    //    [Required]
    //    [DataType(DataType.DateTime)]
    //    [DisplayName("Day")]
    //    public DateTime Date { get; set; }

    //    [Required]
    //    [DataType(DataType.DateTime)]
    //    [DisplayName("Start Time")]
    //    public DateTime StartTime { get; set; }

    //    [Required]
    //    [DataType(DataType.DateTime)]
    //    [DisplayName("End Time")]
    //    public DateTime EndTime { get; set; }

    //    [Required]
    //    [DataType(DataType.Custom)]
    //    [DisplayName("Speaker")]
    //    public int SpeakerId { get; set; }

    //    [Required]
    //    [DataType(DataType.Custom)]
    //    [DisplayName("Track")]
    //    public int TrackId { get; set; }

    //    [Editable(false)]
    //    public DateTime ConferenceStartDate { get; set; }

    //    [Editable(false)]
    //    public DateTime ConferenceEndDate { get; set; }
    //}
}