namespace EventTracker
{
	using System.Data.Services;
    using EventTracker.Services;

    /// <summary>
    /// EventTrackerService Service Class Handler
    /// </summary>
    [System.ServiceModel.ServiceBehavior(IncludeExceptionDetailInFaults = true)]
    [JSONPSupportBehavior]
    public partial class EventTrackerService : DataService<DataManager>
    {
		/// <summary>
        /// Initializes the service.
        /// </summary>
        /// <param name="config">The config.</param>
        public static void InitializeService(DataServiceConfiguration config)
        {
		            config.SetEntitySetAccessRule("Tracks", EntitySetRights.All);
		            config.SetEntitySetAccessRule("Speakers", EntitySetRights.All);
		            config.SetEntitySetAccessRule("Sessions", EntitySetRights.All);
		            config.SetEntitySetAccessRule("Persons", EntitySetRights.All);
		            config.SetEntitySetAccessRule("Organizers", EntitySetRights.All);
		            config.SetEntitySetAccessRule("Conferences", EntitySetRights.All);
		            config.SetEntitySetAccessRule("Attendees", EntitySetRights.All);
		            // TODO: set service behavior configuration options
            // Examples:
            // config.DataServiceBehavior.AcceptCountRequests = true;
            // config.DataServiceBehavior.AcceptProjectionRequests = true;
            config.DataServiceBehavior.MaxProtocolVersion = System.Data.Services.Common.DataServiceProtocolVersion.V2;
        }
        
        /// <summary>
        /// Called when an exception is thrown while processing a request.
        /// </summary>
        /// <param name="args">Exception arguments.</param>
        protected override void HandleException(HandleExceptionArgs args)
        {
            base.HandleException(args);
        }
    }
}