﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.OpenAccess.Diagnostics;
using EventTracker.Infrastructure;
using StructureMap;
using EventTracker.Infrastructure.Helpers;

namespace EventTracker.Web
{
    public partial class AboutForm : System.Web.UI.Page
    {
        private ContextManager contextManager;
        protected void Page_Load(object sender, EventArgs e) 
        {
            contextManager = ObjectFactory.GetInstance<ContextManager>();

            var history = new History(contextManager.Context);

            var list = history.GetDatabaseEvents(null, null, -500);

            if (list != null && list.Count > 0)
            {
                List<ITraceEvent> filteredList = new List<ITraceEvent>(list.Count);
                foreach (var entry in list)
                {
                    // show only select/insert/update/delete
                    //if ((entry.EventType & TraceEventType.MaskAdoExecutions) > 0)
                    filteredList.Add(entry);
                }
                StyleHelper.AddEventColumns(GridView);
                GridView.DataSource = filteredList;
                GridView.DataBind();
            }
        }
    }
}